org.springframework.data.mapping.model

## Enum PreferredConstructorDiscoverer.Discoverers

- java.lang.Object
- - java.lang.Enum<PreferredConstructorDiscoverer.Discoverers>
  - - org.springframework.data.mapping.model.PreferredConstructorDiscoverer.Discoverers

All Implemented Interfaces:
  Serializable, Comparable<PreferredConstructorDiscoverer.Discoverers>

Enclosing interface:
  PreferredConstructorDiscoverer<T,P extends PersistentProperty<P>>

    public static enum PreferredConstructorDiscoverer.Discoverers
    extends Enum<PreferredConstructorDiscoverer.Discoverers>

Helper class to find a `PreferredConstructor`.

Since:
  2.0
Author:
  Oliver Gierke, Christoph Strobl, Roman Rodov, Mark Paluch

### Enum Constant Summary

Enum Constants
Enum Constant and Description
`DEFAULT` Discovers a `PreferredConstructor` for Java types.
`KOTLIN` Discovers a `PreferredConstructor` for Kotlin types.

### Method Summary

All Methods Static Methods Concrete Methods
`static PreferredConstructorDiscoverer.Discoverers` `valueOf(String name)` Returns the enum constant of this type with the specified name.
`static PreferredConstructorDiscoverer.Discoverers[]` `values()` Returns an array containing the constants of this enum type, in the order they are declared.

### Methods inherited from class java.lang.Enum

`clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

### Methods inherited from class java.lang.Object

`getClass, notify, notifyAll, wait, wait, wait`

### Enum Constant Detail

#### DEFAULT

    public static final PreferredConstructorDiscoverer.Discoverers DEFAULT

Discovers a `PreferredConstructor` for Java types.

#### KOTLIN

    public static final PreferredConstructorDiscoverer.Discoverers KOTLIN

Discovers a `PreferredConstructor` for Kotlin types.

### Method Detail

#### values

    public static PreferredConstructorDiscoverer.Discoverers[] values()

Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

    for (PreferredConstructorDiscoverer.Discoverers c : PreferredConstructorDiscoverer.Discoverers.values())
        System.out.println(c);

Returns:
  an array containing the constants of this enum type, in the order they are declared

#### valueOf

    public static PreferredConstructorDiscoverer.Discoverers valueOf(String name)

Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)

Parameters:
  `name` - the name of the enum constant to be returned.
Returns:
  the enum constant with the specified name
Throws:
  `IllegalArgumentException` - if this enum type has no constant with the specified name
  `NullPointerException` - if the argument is null